function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@dftvue2-opentiny/vue-renderless/month-range/vue";
import { defineComponent, $prefix, directive, $props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import Clickoutside from "@dftvue2-opentiny/vue-renderless/common/deps/clickoutside";
import MonthTable from "@dftvue2-opentiny/vue-month-table";
import { iconDoubleRight, iconDoubleLeft } from "@dftvue2-opentiny/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dftvue2-opentiny/vue-theme/month-range/index.css";
var __vue2_script = defineComponent({
  name: $prefix + "MonthRange",
  directives: directive({
    Clickoutside
  }),
  components: {
    MonthTable,
    IconDoubleRight: iconDoubleRight(),
    IconDoubleLeft: iconDoubleLeft()
  },
  props: _extends({}, $props, {
    emitter: Object
  }),
  emits: ["dodestroy", "pick"],
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("transition", {
    attrs: {
      "name": "tiny-zoom-in-top"
    },
    on: {
      "after-leave": function afterLeave($event) {
        return _vm.$emit("dodestroy");
      }
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.visible,
      expression: "state.visible"
    }],
    staticClass: "tiny-picker-panel tiny-date-range-picker tiny-popper",
    class: [{
      "has-sidebar": _vm.slots.sidebar || _vm.state.shortcuts
    }, _vm.state.popperClass]
  }, [_c("div", {
    staticClass: "tiny-picker-panel__body-wrapper"
  }, [_vm._t("sidebar"), _vm.state.shortcuts ? _c("div", {
    staticClass: "tiny-picker-panel__sidebar"
  }, _vm._l(_vm.state.shortcuts, function(shortcut, key) {
    return _c("button", {
      key,
      staticClass: "tiny-picker-panel__shortcut",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          return _vm.handleShortcutClick(shortcut);
        }
      }
    }, [_vm._v(" " + _vm._s(shortcut.text) + " ")]);
  }), 0) : _vm._e(), _c("div", {
    staticClass: "tiny-picker-panel__body"
  }, [_c("div", {
    staticClass: "tiny-picker-panel__content tiny-date-range-picker__content is-left"
  }, [_c("div", {
    staticClass: "tiny-date-range-picker__header"
  }, [_c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-left",
    attrs: {
      "type": "button"
    },
    on: {
      "click": _vm.leftPrevYear
    }
  }, [_c("icon-double-left")], 1), _vm.state.unlinkPanels ? _c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-right",
    class: {
      "is-disabled": !_vm.state.enableYearArrow
    },
    attrs: {
      "type": "button",
      "disabled": !_vm.state.enableYearArrow
    },
    on: {
      "click": _vm.leftNextYear
    }
  }, [_c("icon-double-right")], 1) : _vm._e(), _c("div", [_vm._v(_vm._s(_vm.state.leftLabel))])]), _c("month-table", {
    attrs: {
      "selection-mode": "range",
      "date": _vm.state.leftDate,
      "default-value": _vm.state.defaultValue,
      "min-date": _vm.state.minDate,
      "max-date": _vm.state.maxDate,
      "range-state": _vm.state.rangeState,
      "disabled-date": _vm.state.disabledDate
    },
    on: {
      "changerange": _vm.handleChangeRange,
      "pick": _vm.handleRangePick
    }
  })], 1), _c("div", {
    staticClass: "tiny-picker-panel__content tiny-date-range-picker__content is-right"
  }, [_c("div", {
    staticClass: "tiny-date-range-picker__header"
  }, [_vm.state.unlinkPanels ? _c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-left",
    class: {
      "is-disabled": !_vm.state.enableYearArrow
    },
    attrs: {
      "type": "button",
      "disabled": !_vm.state.enableYearArrow
    },
    on: {
      "click": _vm.rightPrevYear
    }
  }, [_c("icon-double-left")], 1) : _vm._e(), _c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-right",
    attrs: {
      "type": "button"
    },
    on: {
      "click": _vm.rightNextYear
    }
  }, [_c("icon-double-right")], 1), _c("div", [_vm._v(_vm._s(_vm.state.rightLabel))])]), _c("month-table", {
    attrs: {
      "selection-mode": "range",
      "date": _vm.state.rightDate,
      "default-value": _vm.state.defaultValue,
      "min-date": _vm.state.minDate,
      "max-date": _vm.state.maxDate,
      "range-state": _vm.state.rangeState,
      "disabled-date": _vm.state.disabledDate
    },
    on: {
      "changerange": _vm.handleChangeRange,
      "pick": _vm.handleRangePick
    }
  })], 1)])], 2)])]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var MonthRange = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
MonthRange.install = function(Vue) {
  Vue.component(MonthRange.name, MonthRange);
};
MonthRange.version = version;
export {
  MonthRange as default
};
